/** @jsx jsx */
/** @jsxFrag React.Fragment */
import React, { Component, ReactElement, SyntheticEvent } from 'react';
import { jsx } from '@instructure/emotion';
import type { TreeBrowserCollectionProps, TreeCollectionState } from './props';
import type { CompareObject } from '../props';
import { CollectionItem, CollectionProps, CollectionData } from '../props';
/**
---
parent: TreeBrowser
id: TreeBrowser.Collection
---
**/
declare class TreeCollection extends Component<TreeBrowserCollectionProps, TreeCollectionState> {
    static readonly componentId = "TreeBrowser.Collection";
    static allowedProps: readonly ("collections" | "items" | "expanded" | "onItemClick" | "getItemProps" | "getCollectionProps" | "onCollectionClick" | keyof import("../props").TreeBrowserCommonProps | "level" | "position" | "onKeyDown" | "numChildren" | "selection" | "isCollectionFlattened" | "compareFunc" | keyof {
        id: number | string;
        name: string;
        descriptor?: string;
        containerRef?: (el: HTMLElement | null) => void;
        renderBeforeItems?: ReactElement;
        renderAfterItems?: ReactElement;
    })[];
    static propTypes: import("@instructure/shared-types").PropValidators<"collections" | "items" | "expanded" | "onItemClick" | "getItemProps" | "getCollectionProps" | "onCollectionClick" | keyof import("../props").TreeBrowserCommonProps | "level" | "position" | "onKeyDown" | "numChildren" | "selection" | "isCollectionFlattened" | "compareFunc" | keyof {
        id: number | string;
        name: string;
        descriptor?: string;
        containerRef?: (el: HTMLElement | null) => void;
        renderBeforeItems?: ReactElement;
        renderAfterItems?: ReactElement;
    }>;
    static defaultProps: {
        collections: never[];
        items: never[];
        expanded: boolean;
        selection: string;
        size: string;
        variant: string;
        getItemProps: (props: unknown) => unknown;
        getCollectionProps: (props: unknown) => unknown;
        isCollectionFlattened: boolean;
    };
    ref: Element | null;
    constructor(props: TreeBrowserCollectionProps);
    componentDidMount(): void;
    componentDidUpdate(): void;
    get itemsLevel(): number;
    handleFocus: (e: SyntheticEvent, item: CollectionData) => void;
    handleBlur: (e: SyntheticEvent, _item: CollectionData) => void;
    handleCollectionClick: (e: React.MouseEvent) => void;
    handleCollectionKeyDown: (e: React.KeyboardEvent) => void;
    get collectionsCount(): number;
    get itemsCount(): number;
    get childCount(): number;
    sortChildren(): CompareObject[];
    renderChildren(): jsx.JSX.Element;
    renderCollectionChildren(collectionId: string | number | undefined, child: ReactElement, position: number, keyword: 'before' | 'after'): jsx.JSX.Element;
    renderCollectionNode(collection: CollectionProps, position: number): jsx.JSX.Element;
    renderItemNode(item: CollectionItem, position: number): jsx.JSX.Element;
    getCommonButtonProps(): {
        id: string | number;
        name: string;
        descriptor: string | undefined;
        size: "small" | "medium" | "large" | undefined;
        variant: "folderTree" | "indent" | undefined;
        itemIcon: import("@instructure/shared-types").Renderable;
        level: number;
        renderContent: ((props: import("../..").TreeBrowserButtonProps) => JSX.Element) | undefined;
    };
    render(): jsx.JSX.Element;
}
export default TreeCollection;
export { TreeCollection };
//# sourceMappingURL=index.d.ts.map