/** @jsx jsx */
import { Component } from 'react';
import { jsx } from '@instructure/emotion';
import type { TreeBrowserNodeProps } from './props';
/**
---
parent: TreeBrowser
id: TreeBrowser.Node
---
A helper class used to render the :renderBeforeItems and :renderAfterItems
in the TreeBrowser.
**/
declare class TreeNode extends Component<TreeBrowserNodeProps> {
    static readonly componentId = "TreeBrowser.Node";
    static allowedProps: readonly ("thumbnail" | "size" | "variant" | "itemIcon" | "id" | "onClick" | "selected" | "focused" | "level" | "containerRef" | "children" | "onKeyDown")[];
    static propTypes: import("@instructure/shared-types").PropValidators<"thumbnail" | "size" | "variant" | "itemIcon" | "id" | "onClick" | "selected" | "focused" | "level" | "containerRef" | "children" | "onKeyDown">;
    static defaultProps: {
        size: string;
        variant: string;
        selected: boolean;
        focused: boolean;
    };
    ref: Element | null;
    componentDidMount(): void;
    componentDidUpdate(): void;
    handleRef: (el: HTMLDivElement) => void;
    renderItemImage(): jsx.JSX.Element | undefined;
    render(): jsx.JSX.Element;
}
export default TreeNode;
export { TreeNode };
//# sourceMappingURL=index.d.ts.map